︠ac0af08a-c54e-49d9-9dd3-55ee8bfe4dadi︠
%md
## Exemple
On considère a surface $z=\phi(x,y)= x^2 - 2 y^2 +xy-1$.
Ci bas :
- Ses courbes de niveau,
- Son champ gradient.
︡4a5c9bcf-678a-410b-9a8e-b3c9c364d278︡{"md":"## Exemple\nOn considère a surface $z=\\phi(x,y)= x^2 - 2 y^2 +xy-1$.  \nCi bas :\n- Ses courbes de niveau,\n- Son champ gradient.\n"}︡
︠a970803e-5501-4370-abab-f0dc9055a515s︠
var('x,y')
f(x,y)=x^2-2*y^2+x*y-1
C=contour_plot(f, (x,-1, 1), (y,-1, 1),fill=False, cmap='autumn',linestyles='solid',colorbar=True)
Grad=plot_vector_field(f.gradient(),(x,-1,1),(y,-1,1),color='blue')
show(C+Grad, figsize=6)
︡39d66736-ce03-4837-9134-cb196105aa02︡{"stdout":"(x, y)\n"}︡{"file":{"filename":"/home/user/.sage/temp/project-db013a35-ea11-498b-a802-aaeadc1fa2a7/945/tmp_KAh_1Z.svg","show":true,"text":null,"uuid":"bece2009-d295-4926-9673-476b61dc5f05"},"once":false}︡{"done":true}︡
︠e86768c5-23b8-4ba9-ab73-d30da720a403s︠
cmsel = [colormaps['autumn'](i) for i in sxrange(0,1,0.05)]
Surff=plot3d(f,(x,-1,1),(y,-1,1),adaptive=True, color=cmsel)
show(Surff)
︡a962c322-047d-4ba9-b04e-bf258d94ac6b︡{"file":{"filename":"de437a29-5450-42b7-8c32-92897bef8bb1.sage3d","uuid":"de437a29-5450-42b7-8c32-92897bef8bb1"}}︡{"done":true}︡
︠30f16fd2-df3d-4fc5-86eb-a0f8c8b4cda5i︠
%md
Les lignes de courant du champ gradient sont les solutions de \[-(x-4y) + (2x+y) y'(x) = 0\]
︡839d6f47-a931-4141-98c6-bbe0c222c400︡{"md":"Les lignes de courant du champ gradient sont les solutions de \\[-(x-4y) + (2x+y) y'(x) = 0\\]\n"}︡
︠f8c330c6-21e9-45cb-9514-fc40e02dcc47s︠
from sage.calculus.desolvers import desolve_system_rk4

var('x')
y = function('y')(x) # p est une fonction de la variable t
EDO = diff(y,x) == (x-4*y)/(2*x+y) # On déclare l'EDO à considérer. Bien noter le double signe égal.
g = Graphics() # On commence par créer un graphique vide
for i in srange(-1,1,0.1): # On produit la liste des nobres de 0 à 12, par pas de 0.2. Ces nombres serviront de conditions initiales
	g += line(desolve_rk4(EDO,y,ics=[0,i], step = 0.02, end_points=[-1,1]), color="green") # Au graphique, on rajoute la courbe solution de l'EDO avec la nouvelle cond. init.
var('y')# On fait que y devienne une variable, nécessaire si on veut dessiner le champ.
#g+= plot_slope_field((x-4*y)/(2*x+y), (x,-2,2), (y,-2,2), color="red",  headlength =2)# on rajoute le champ
g+= Grad
g.show(ymin=-1, ymax = 1, figsize=6, aspect_ratio=1)# On montre le tout, en spécifiant l'étendue de l'axe des ordonnées.
︡75d1fbb7-3666-469c-a75b-5c8b975f5cfd︡{"stdout":"x\n"}︡{"stdout":"y\n"}︡{"file":{"filename":"/home/user/.sage/temp/project-db013a35-ea11-498b-a802-aaeadc1fa2a7/945/tmp_GTorAo.svg","show":true,"text":null,"uuid":"c7611cdc-27dd-483a-b96f-4402455a92eb"},"once":false}︡{"done":true}︡
︠a9b15e67-8875-471d-a7ed-9ee0df5cc6e3s︠
g+=C
g.show(ymin=-1, ymax = 1, figsize=6, aspect_ratio=1)
︡1cc0f42b-09d1-4739-9642-96b84f87ed58︡{"file":{"filename":"/home/user/.sage/temp/project-db013a35-ea11-498b-a802-aaeadc1fa2a7/945/tmp_Fnk2b8.svg","show":true,"text":null,"uuid":"3a80cc12-64c9-48ba-bf22-f567c097f82b"},"once":false}︡{"done":true}︡
︠2c3b4038-7f2b-4b15-a122-d96798079778︠









